﻿namespace IEnumerableIteratorMethods_ConcurrentEnum {
    class A {
        public int x;

        public IEnumerable<int> Range(int from, int to) {
            Console.WriteLine("+ A.Range: before 1st yield return");
            from--;
            to++;
            for (int i = from; i <= to; i++) {
                yield return x + i;
            }
            x += 100;
            Console.WriteLine("+ A.Range: after last yield return");
        }
    }

    class Program {
        static void Main(string[] args) {
            A a = new A();

            var range = a.Range(1, 5);

            Console.WriteLine("Main: before foreach");
            foreach (int vo in range) {
                Console.WriteLine($"Main: OUTER: got {vo}");
                if (vo == 3) {
                    foreach (int vi in range) {
                        Console.WriteLine($"Main: INNER: got {vi}");
                    }
                }
            }
            Console.WriteLine("Main: after foreach");

        }
    }
}