﻿using System.Text.Json.Serialization.Metadata;
using System.Text.Json;
using System.Reflection;

namespace SerializationWithTextJson {

    record Person(string FirstName, string LastName, int Age);

    class Child {
        private string _name;
        private int _age;

        public Child(string name, int age) {
            _name = name;
            _age = age;
        }

        public override string ToString() => $"Child({_name}, {_age})";
    }

    internal class Program {
        static void Main(string[] args) {
            var p = new Person(FirstName: "John", LastName: "Doe", Age: 22);

            Console.WriteLine("Person instance in JSON:");
            Console.WriteLine(JsonSerializer.Serialize(p));
            Console.WriteLine();

            Console.WriteLine("Person instance in JSON (WriteIndented = true):");
            var basicOptions = new JsonSerializerOptions { WriteIndented = true };
            Console.WriteLine(JsonSerializer.Serialize(p, basicOptions));
            Console.WriteLine();

            var c = new Child(name: "Jack", age: 12);

            Console.WriteLine("Child instance in JSON:");
            Console.WriteLine(JsonSerializer.Serialize(c, basicOptions));
            Console.WriteLine();
        }
    }
}